"use strict";var __awaiter=this&&this.__awaiter||function(t,e,r,i){return new(r||(r=Promise))(function(o,a){function s(t){try{u(i.next(t))}catch(t){a(t)}}function n(t){try{u(i.throw(t))}catch(t){a(t)}}function u(t){t.done?o(t.value):new r(function(e){e(t.value)}).then(s,n)}u((i=i.apply(t,e||[])).next())})};Object.defineProperty(exports,"__esModule",{value:!0});const fs=require("fs-extra"),path=require("path"),del=require("del"),url=require("url"),_=require("lodash"),appError_1=require("./appError"),platform_1=require("./modules/platform"),utility_1=require("./modules/utility"),config_1=require("./modules/data/config");class ServerManagement{constructor(t,e,r){this.onSynchronizePrinterTime=(()=>{}),this.db=t,this.printer=e,this.printerModel=r,this.countryCode=utility_1.default.native.getCountryCode()}init(t){this.createTempFolder(t)}dispose(){this.synchronizeTimeTimer&&clearInterval(this.synchronizeTimeTimer)}updateSetting(t){_.merge(config_1.default.getInst().userSettings,t),config_1.default.getInst().save()}isShowEULA(){return config_1.default.getInst().settings.showEULA}getEULA(t){return __awaiter(this,void 0,void 0,function*(){let e="";switch((t=t||"en").toUpperCase()){case"DE":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_german-utf8.txt");break;case"ES":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_spanish-utf8.txt");break;case"FR":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_french-utf8.txt");break;case"IT":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_italian-utf8.txt");break;case"JA":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_japanese-utf8.txt");break;case"KO":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_korean-utf8.txt");break;case"NL":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_dutch-utf8.txt");break;case"PT":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_portuguese-utf8.txt");break;case"RU":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_russian-utf8.txt");break;case"TR":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_turkish-utf8.txt");break;case"ZH-TW":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_tchinese-utf8.txt");break;case"ZH-CN":e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_schinese-utf8.txt");break;case"EN":default:e=path.join(platform_1.default.ScriptsDir,"views/eula/EULA_english-utf8.txt")}const r=yield fs.readFile(e).catch(t=>null),i={eula:r?r.toString():""};return Promise.resolve(i)})}getContentsServerAddress(){return{address:config_1.default.getInst().settings.contentsServerAddress}}getCountryCode(){return{countrycode:config_1.default.getInst().settings.region||this.countryCode}}getPath(){return{emxDir:platform_1.default.EmxDir,profileDir:platform_1.default.ProfileDir}}getConfig(...t){return this.db.getConfiguration(...t)}setConfig(t){return __awaiter(this,void 0,void 0,function*(){this.normalizeProxyAddressSettings(t);const e=yield this.db.setConfiguration(t);return e.err||t.TimeSynchronization,Promise.resolve(e)})}execApplication(t,e){return __awaiter(this,void 0,void 0,function*(){let r;switch(t){case"accounting":r=yield this.getAccountingAppCmd();break;case"mediaSettings":r=yield this.getMediaSettingAppCmd(e)}if(!r)return Promise.resolve({err:new appError_1.default(2e3)});return utility_1.default.native.executeAsActiveUser(r)?Promise.resolve({}):Promise.resolve({err:new appError_1.default(2009)})})}getAccountingAppCmd(){return __awaiter(this,void 0,void 0,function*(){const t=yield platform_1.default.getAccountingToolPath();return t?Promise.resolve(`"${t}" /UI`):Promise.resolve(void 0)})}getMediaSettingAppCmd(t){return __awaiter(this,void 0,void 0,function*(){const e=yield platform_1.default.getStartupMediaSettingToolPath();if(e){const r=0!==platform_1.default.RelayModulePath.length?`"${platform_1.default.RelayModulePath}" `:"",i=t&&t.queue?`-p "${t.queue}"`:"";return Promise.resolve(`${r}"${e}" ${i} -edit`)}return Promise.resolve(void 0)})}createTempFolder(t){fs.access(platform_1.default.TempDir,fs.constants.R_OK+fs.constants.W_OK,e=>{e&&"ENOENT"===e.code?fs.mkdir(platform_1.default.TempDir,t):del([path.join(platform_1.default.TempDir,"**","*.*")])})}normalizeProxyAddressSettings(t){1===t.EMXImport&&(delete t.HttpProxy,delete t.HttpProxyPort,delete t.HttpsProxy,delete t.HttpsProxyPort),t.hasOwnProperty("HttpProxy")||delete t.HttpProxyPort,t.hasOwnProperty("HttpsProxy")||delete t.HttpsProxyPort;const e=(t,e)=>{if(""===t)return{address:"",port:""};/^https?:\/\//i.test(t)||(t=`http://${t}`);const r=e&&0!==Number(e)?`${t}:${e}`:t,i=url.parse(r);return t=`${i.protocol}//${i.hostname}`,e=i.port?i.port:/^https/i.test(i.protocol)?"443":"80",{address:t,port:e}};if(t.hasOwnProperty("HttpProxy")){const r=e(t.HttpProxy,t.HttpProxyPort);t.HttpProxy=r.address,t.HttpProxyPort=r.port}if(t.hasOwnProperty("HttpsProxy")){const r=e(t.HttpsProxy,t.HttpsProxyPort);t.HttpsProxy=r.address,t.HttpsProxyPort=r.port}}}ServerManagement.synchronizeTimeStartDelay=144e5,ServerManagement.synchronizeTimeInterval=432e5,exports.default=ServerManagement;